/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  Previously released under Apache License 2.0; now licensed under MPL 2.0.
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import java.lang.reflect.Type;



public class TokenDeserializer implements JsonDeserializer<Token> {

  public TokenDeserializer() {}



  @Override
  public Token deserialize(JsonElement json, Type type, JsonDeserializationContext context)
      throws JsonParseException {

    Token secret = new Token();
    JsonObject jsonobject = json.getAsJsonObject();
    try {
      String email = jsonobject.getAsJsonPrimitive(Token.EMAIL).getAsString();
      secret.setEMail(email);
    }
    catch (NullPointerException e) {}
    try {
      String userid = jsonobject.getAsJsonPrimitive(Token.USERID).getAsString();
      secret.setUserid(userid);
    }
    catch (NullPointerException e) {}
    try {
      String password = jsonobject.getAsJsonPrimitive(Token.PASSWORD).getAsString();
      secret.setPassword(password);
    }
    catch (NullPointerException e) {}
    try {
      String aes = jsonobject.getAsJsonPrimitive(Token.AES).getAsString();
      secret.setAES(aes);
    }
    catch (NullPointerException e) {}
    try {
      String onetime = jsonobject.getAsJsonPrimitive(Token.ONETIME).getAsString();
      secret.setOnetime(onetime);
    }
    catch (NullPointerException e) {}
    return secret;
  }

}
